(function () {

	var table = app.selection && app.selection.table;
	if (!table)
		return;

	return({
		version: 1,
		setup: {
			title: "Add Tag to Listed Items (" + table + ")",
			id: "com.sassafras.adhoctag",
			fields: [
				{
					id: "listfile",
					label: table + " List:",
					type: "file",
					required: true
				},
				{
					id: "tag",
					label: "Tag:",
					type: "text",
					default: localStorage.getItem("tag"),
					required: true
				}
			]
		},
		proceed: function (params) {
			var idlist = [];
			localStorage.setItem("tag", params.tag);
			if (params.listfile) {
				params.listfile.forEach(function (line) {
					if (line && line.charAt(0) != '#')
						idlist.push(line);
				});

				var view = new KSView(table.toLowerCase());
				view.select(idlist);
				view.forEach(function (obj) {
					var arr = [];
					if (obj.tags && obj.tags.length)
						merge(arr, expand(obj.tags));
					merge(arr, [ params.tag ]);
					obj.tags = arr.join(";");
					obj.commit();
				});
			}
		}
	});

	function expand (a) {
		return(a.split(";")
				.map(function (e) { return(e.trim()); })
				.filter(function (e) { return(e.length > 0); }));
	}

	function merge (a, b) {
		b.forEach(function (e) {
			if (a.indexOf(e) < 0)
				a.push(e);
		});
	}

})();
